#!/usr/bin/perl
# indexsoft intuitive mailer
# http://www.indexsoft.com

$|++;
$VER = '1.91';
&ReadParameters();
push (@INC, './'); push (@INC, './modules');
print &TopOfPage() if $P{'todo'} ne 'downloadsearch';
eval('use SendMail;'); $sendmailerror = $@;
eval('use Mail::POP3Client;'); $pop3error = $@;
eval('use DBI;'); $nodbi = $@;
if (($P{'todo'} eq 'saveconfig') and $P{'cfgfilecontent'})
{
	print &Operation('save configuration file intuitive.pm');
	open(FILE, ">intuitive.pm") || print &HoldError('can not rewrite configuration file <i>\'intuitive.pm\'</i>');
	binmode('FILE');
	print FILE $P{'cfgfilecontent'};
	close FILE;
}
eval('require "intuitive.pm";'); $configerror = $@;
$ENV{'WINDIR'}?($DirSeparator = '\\'):($DirSeparator = '/');
&DBIInit() if !$nodbi;
$nowtime = time;

####### download search
if ($P{'todo'} eq 'downloadsearch')
{
	print "Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-Disposition: attachment; filename=searchresults.txt\nContent-type: application/binary\n\n";
	binmode('STDOUT'); 
	$sth = $MLDBH->prepare($P{'statement'});
	$sth -> execute();
	while (($uname, $uemail) = $sth->fetchrow_array())
	{
		print "$uname<$uemail>\n";
	}
	exit;
}
####### config and errors
if (($P{'todo'} eq 'checkver'))
{
	print &Header('Check for new version of the indexsoft intuitive mailer');
	print qq{<p><iframe src="http://www.indexsoft.com/checkver.px?program=intuitive&ver=$VER&r=$nowtime" width="550" height="100" marginwidth="0" marginheight="0" scrolling="no" frameborder="0"><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript" src="http://www.indexsoft.com/checkver.px?program=intuitive&ver=$VER&r=$nowtime&method=javascript"></SCRIPT></iframe></p>};
}
elsif (($P{'todo'} eq 'rateus'))
{
	print &Header(qq{Rate indexsoft intuitive mailer at HotScripts.com});
	print qq{<p><form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST" target="_new"><input type="hidden" name="ID" value="19109"><select name="rate" size="1" style="width: 250px;"><option selected>Select</option><option value="5">Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select><input type="submit" value="Go!"></form></p><p>&nbsp;</p>};
	print &Header(qq{Rate indexsoft intuitive mailer at ScriptSearch.com});
	print qq{<p><form action="http://www.scriptsearch.com/cgi-bin/rateit.cgi" method="post" target="_new"><input type="hidden" name="ID" value="6869"><select name="rate" size="1" style="width: 250px;"><option value="--">- Select -</option><option value="5">Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select><input type="submit" value="Go!"></form></p><p>&nbsp;</p>};
}
elsif ($nodbi)
{
	print &HoldError($nodbi);
	print '<p><i>DBI must be installed to use <i>indexsoft intuitive mailer</i>. Please install DBI and DBD::mysql. You can download DBI from <a href="http://cpan.org/modules/by-category/07_Database_Interfaces/DBI/" target="_blank">http://cpan.org/modules/by-category/07_Database_Interfaces/DBI/</a>. DBD::mysql can be downloaded from <a href="http://cpan.org/modules/by-category/07_Database_Interfaces/DBD/" target="_blank">http://cpan.org/modules/by-category/07_Database_Interfaces/DBD/</a></p>';
}
elsif ($sendmailerror)
{
	print &HoldError($sendmailerror);
	print '<p><i>SendMail</i> must be installed to use <i>indexsoft intuitive mailer</i>. You can download original <i>sendmail.pm</i> from <a href="http://www.tneoh.zoneit.com/perl/SendMail/" target="_blank">http://www.tneoh.zoneit.com/perl/SendMail/</a> or patched from <a href="http://www.indexsoft.com/downloads.px" target="_blank">http://www.indexsoft.com/downloads/</a></p><p>See <a href="http://www.indexsoft.com/help.px#sendmail" target="_blank">instructions</a> how to install SendMail.</p>';
}
elsif ($P{'todo'} eq 'changeparams')
{
	print &Operation('change indexsoft intuitive mailer parameters');
	foreach  $pname(keys(%P)) { $P{"$pname"} =~ s/\0/\n/g; $MLDBH -> do("update _iml_tune set pvalue = ".$MLDBH->quote($P{"$pname"})." where pname = '$pname'"); }
	for ($i = 0; $i <= 4; ++$i)
	{
		$MLDBH -> do("update _iml_tune set pvalue = '0' where pname = 'SUShtml$i'") if !$P{"SUShtml$i"};
		$MLDBH -> do("update _iml_tune set pvalue = '' where pname = 'SUSAttach$i'") if !$P{"SUSAttach$i"};
	}
	print &EditConfigForm();
}
elsif ($P{'createdb'} and !$configerror)
{
	$MLDBH->disconnect if (defined $MLDBH);
	$MLDBH = DBI->connect("DBI:mysql:database=;host=$mySQLHost",$mySQLUser,$mySQLPassword);
	$dbierror = DBI->errstr;
	if (!$dbierror)
	{
		print &Operation('create database and tables');
		$MLDBH -> do("create database if not exists `$mySQLDBName`");
		$MLDBH -> do("use `$mySQLDBName`");
		my ($mailheaders) = $MLDBH->quote(qq{Content-Type: text/plain; charset=us-ascii\nContent-Transfer-Encoding: 7bit\n});
		$installdir = $ENV{'SCRIPT_FILENAME'}; $installdir =~ s/\/intuitive.cgi$//gi;	$installdir =~ s/\//\\/g if ($ENV{'WINDIR'});
		$attachdir = $MLDBH->quote($installdir);
		$attachshareddir = $MLDBH->quote("$installdir$DirSeparator".'shared_dir');
		$pidfile = $MLDBH->quote("$installdir$DirSeparator".'delivery.pid');
		if ($P{'createdb'} eq '2')
		{
			$MLDBH -> do(q{DROP TABLE IF EXISTS _iml_emails;});
			$MLDBH -> do(q{DROP TABLE IF EXISTS _iml_members;});
			$MLDBH -> do(q{DROP TABLE IF EXISTS _iml_mlists;});
			$MLDBH -> do(q{DROP TABLE IF EXISTS _iml_users;});
			$MLDBH -> do(q{DROP TABLE IF EXISTS _iml_tune;});
			$MLDBH -> do(q{DROP TABLE IF EXISTS _iml_dispatches;});
			$MLDBH -> do(q{DROP TABLE IF EXISTS _iml_queries;});
		}
		$MLDBH -> do(q{CREATE TABLE _iml_emails ( eid int(11) unsigned NOT NULL auto_increment,  emid int(11) unsigned NOT NULL default '0',  ename varchar(128) NOT NULL default '',  etext text NOT NULL,  ehtml set('0','1') NOT NULL default '0',  PRIMARY KEY  (eid)) TYPE=MyISAM;});
		$MLDBH -> do(q{CREATE TABLE _iml_members (  mmid int(11) unsigned NOT NULL default '0',  muid int(11) unsigned NOT NULL default '0',  PRIMARY KEY  (mmid,muid)) TYPE=MyISAM;});
		$MLDBH -> do(q{CREATE TABLE _iml_mlists (  mid int(11) unsigned NOT NULL auto_increment,  mname varchar(64) NOT NULL default '',  mdir varchar(128) NOT NULL default '',  memail varchar(128) NOT NULL default '',  PRIMARY KEY  (mid),  UNIQUE KEY mname (mname)) TYPE=MyISAM;});
		$MLDBH -> do(q{CREATE TABLE _iml_users (  uid int(11) unsigned NOT NULL auto_increment,  uname varchar(128) NOT NULL default '',  uemail varchar(128) NOT NULL default '',  uact set('0','1') NOT NULL default '1',  subscribed datetime DEFAULT '1970-01-01 00:00:00', uinfo varchar(255) NOT NULL default '', PRIMARY KEY  (uid),  UNIQUE KEY uemail (uemail)) TYPE=MyISAM;});
		$MLDBH -> do(q{CREATE TABLE _iml_tune (  pname varchar(16) NOT NULL default '',  pvalue text NOT NULL,  porder int(3) unsigned NOT NULL default '0',  suborder int(3) unsigned NOT NULL default '0', PRIMARY KEY  (pname)) TYPE=MyISAM;});
		$MLDBH -> do(q{CREATE TABLE _iml_dispatches ( did int(11) unsigned NOT NULL auto_increment, dname varchar(128) NOT NULL default '', dispatch mediumblob NOT NULL, dstart datetime DEFAULT '1970-01-01 00:00:00' NOT NULL, PRIMARY KEY  (did)) TYPE=MyISAM;});
		$MLDBH -> do(q{CREATE TABLE _iml_queries ( qid int(11) unsigned NOT NULL auto_increment, qname varchar(128) NOT NULL default '', qdbi varchar(128) NOT NULL default '', qstatement varchar(128) NOT NULL default '', PRIMARY KEY  (qid)) TYPE=MyISAM;});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('AttachDir',$attachdir,1,10);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('AttachSharedDir',$attachshareddir,1,20);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('FromEmail','$ENV{'SERVER_ADMIN'}',1,30);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('ReturnPath','$ENV{'SERVER_ADMIN'}',1,35);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('MailHeaders',$mailheaders,1,40);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('Inline','gif,png,jpg,jpeg,html,htm',1,45);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('SubscriberName','Subscriber',1,50);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('Convert1','',1,60);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('Convert2','',1,70);});
		$MLDBH -> do(q{INSERT INTO _iml_tune VALUES ('SMTP','localhost',2,10);});
		$MLDBH -> do(q{INSERT INTO _iml_tune VALUES ('SMTPPort','25',2,20);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('PIDFile',$pidfile,2,30);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('DebugDelivery','0',2,40);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('DelayDelivery','0',2,45);});
		$MLDBH -> do(qq{INSERT INTO _iml_tune VALUES ('POP3Auth','',2,50);});
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSEmail','mlistemail-$ENV{'SERVER_ADMIN'}',3,10);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSPOPHost','localhost',3,20);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSPOPLogin','',3,30);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSPOPPassword','',3,40);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSSMTP','localhost',3,50);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSSMTPPort','25',3,60);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSMlists','',3,70);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSBanning','',3,80);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSSubject0',".$MLDBH->quote('Help message').',10,10);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSMessage0',".$MLDBH->quote(qq{Dear %name%\n\n Available maillists:\n %allmlists%\n Select mlist ID from this list.\n To subscribe: send any message to %mlistemail% with subject "subscribe ID"\n To unsubscribe: send any message to %mlistemail% with subject "unsubscribe ID"\n To get help and list of available maillists: send any message to %mlistemail% with subject "help"\n\nThank you.}).',10,20);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUShtml0','0',10,21);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSAttach0','',10,22);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSSubject1',".$MLDBH->quote('Confirm subscription for %mlist%').',10,30);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSMessage1',".$MLDBH->quote("Dear %name%\n\n To subscribe email %email% to maillist %mlist% simply reply to this message.\n Be sure that email from wich you will send this message is equally to %email%.\n Do not change subject of the message.\n\nThank you.").',10,40);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUShtml1','0',10,41);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSAttach1','',10,42);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSSubject2',".$MLDBH->quote('You are successfully subscribed to %mlist%').',10,50);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSMessage2',".$MLDBH->quote("Dear %name%\n\n Email address %email% successfully subscribed to maillist %mlist%.\n\nThank you.").',10,60);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUShtml2','0',10,61);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSAttach2','',10,62);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSSubject3',".$MLDBH->quote('Confirm unsubscription from %mlist%').',10,70);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSMessage3',".$MLDBH->quote("Dear %name%\n\n To unsubscribe email %email% from maillist %mlist% simply reply to this message.\n Be sure that email from wich you will send this message is equally to %email%.\n Do not change subject of the message.\n\nThank you.").',10,80);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUShtml3','0',10,81);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSAttach3','',10,82);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSSubject4',".$MLDBH->quote('You are successfully unsubscribed from %mlist%').',10,90);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSMessage4',".$MLDBH->quote("Dear %name%\n\n Email address %email% successfully unsubscribed from maillist %mlist%.\n\nThank you.").',10,100);');
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUShtml4','0',10,101);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('SUSAttach4','',10,102);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('ExtMessagesHost','localhost',5,10);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('ExtMessagesLogin','',5,20);");
		$MLDBH -> do("INSERT INTO _iml_tune VALUES ('ExtMessagesPass','',5,30);");
	}
	$MLDBH->disconnect if (defined $MLDBH);
	&DBIInit();
	print &EditConfigForm();
}
elsif ($P{'todo'} eq 'configure' or $P{'todo'} eq 'saveconfig' or $configerror or $dbierror)
{
	print &EditConfigForm();
}
####### deletepop3messages
elsif ($P{'todo'} eq 'deletepop3messages')
{
	print &Operation('delete messages from mailbox');
	$pop = new Mail::POP3Client(HOST=>"$ExtMessagesHost", AUTH_MODE=>"PASS", DEBUG=>'0');
	$pop->User("$ExtMessagesLogin");
	$pop->Pass("$ExtMessagesPass");
	$pop->Connect();
	if ($pop->Message() =~ /^\+OK/i) { grep($pop->Delete($_), split(/\0/, $P{'pop3id'})); $pop->Close(); }
	else { print &HoldError('POP auth: '.$pop->Message()); }
	print &MessagesList();
}
####### checknewusers
elsif ($P{'todo'} eq 'checknewusers')
{
	if ($P{'check'} == 1)
	{
		print &Operation('run subscribe.cgi');
		my ($cmd) = '.'.$DirSeparator.'subscribe.cgi';
		$cmd = "$^X $cmd" if $ENV{'WINDIR'};
		print '<pre style="font-size:11px;">';
		my $code = system("$cmd 2>&1");
		print '</pre>';
	}
	print &Header('Check maillist mailbox for subscriptions and unsubscriptions requests');
	print q{<form action="intuitive.cgi"><input type="hidden" name="todo" value="checknewusers"><input type="hidden" name="check" value="1">
	<p>You can run subscribe.cgi now. subscribe.cgi will check maillist mailbox for subscription and unsubscription requests by the users. This will create and send all needed messages to those users. You can run it from here before create cron jobs for subscribe.cgi or set-up mail daemon to run subscribe.cgi automatically after message is arrived to maillist mailbox.<br><br></p>
	<input type="submit" value="Run subscribe.cgi">
	</form>};
}
####### queries
elsif ($P{'todo'} eq 'delqueries' and $P{'qid'})
{
	print &Operation("delete selected queries");
	$qids = $P{'qid'};
	$qids =~ s/\0/\,/g;
	$MLDBH -> do("delete from _iml_queries where qid in ($qids)");
	print &VeiwQueries();
}
elsif ($P{'todo'} eq 'updatequery' and $P{'qid'} and $P{'qname'} and $P{'qdbi'} and $P{'qstatement'})
{
	print &Operation("change query <i>'$P{'qname'}'</i>");
	eval('$EXTDBH = DBI->connect('.$P{'qdbi'}.')');
	if ($@) { print &HoldError($@); print &EditQueryForm($P{'qid'}); }
	else { $MLDBH -> do('update _iml_queries set qname = '.$MLDBH->quote($P{'qname'}).', qdbi = '.$MLDBH->quote($P{'qdbi'}).', qstatement = '.$MLDBH->quote($P{'qstatement'})." where qid = $P{'qid'}"); print &VeiwQueries(); }
}
elsif (($P{'todo'} eq 'editquery' and $P{'qid'}) or ($P{'from'} eq 'editquery'))
{
	print &EditQueryForm($P{'qid'});
}
elsif ($P{'todo'} eq 'addquery' and $P{'qname'} and $P{'qdbi'} and $P{'qstatement'})
{
	print &Operation("add query <i>'$P{'qname'}'</i>");
	eval('$EXTDBH = DBI->connect('.$P{'qdbi'}.')');
	if ($@) { print &HoldError($@) }
	else { $MLDBH -> do('insert into _iml_queries (qname, qdbi, qstatement) values ('.$MLDBH->quote($P{'qname'}).','.$MLDBH->quote($P{'qdbi'}).','.$MLDBH->quote($P{'qstatement'}).')'); }
	print &VeiwQueries();
}
elsif ($P{'todo'} eq 'viewqueries' or $P{'from'} eq 'viewqueries')
{
	print &VeiwQueries();
}
####### dispatches
elsif ($P{'todo'} eq 'killdelivery' and $P{'pid'})
{
	print &Operation('delete PID file and kill delivery process');
	unlink ("$PIDFile") || print &HoldError("can not delete file <i>'$PIDFile'</i>");
	if (kill(0,$P{'pid'})) { kill(1,$P{'pid'}) || print &HoldError("can not kill process PID: $P{'pid'}") }
	print &VeiwDispatches();
}
elsif ($P{'todo'} eq 'deldispatch' and $P{'did'})
{
	print &Operation('delete selected dispatches');
	if (!-e "$PIDFile")
	{
		$dids = $P{'did'};
		$dids =~ s/\0/\,/g;
		$MLDBH -> do("delete from _iml_dispatches where did in ($dids)");
	}
	else { print &HoldError("can not delete dispatches. delivery in progress.") }
	print &VeiwDispatches();
}
elsif ($P{'todo'} eq 'savedispatch' and $P{'subject'} and $P{'body'} and $P{'fromemail'}and ($P{'mid'} or $P{'statement'} or $P{'qid'}))
{
	$P{'dstart'} = '1970-01-01 00:00:00' if !$P{'dstart'};
	if ($P{'filename1'})
	{
		$filehandle1 = $MULTIPARTQUERY->param('filename1');
		$filename1 = lc($P{'filename1'});
		$filename1 =~ s!^.*(\\|\/)!!; 
		open(OUT, ">$AttachSharedDir$DirSeparator$filename1") || print &HoldError("can not save file <i>'$AttachSharedDir$DirSeparator$filename1'</i>");
		binmode OUT;
		while (read($filehandle1, $buffer, 1024)) { print OUT $buffer; }
		close OUT;
		push (@files, "$AttachSharedDir$DirSeparator$filename1");
	}
	if ($P{'filename2'})
	{
		$filehandle2 = $MULTIPARTQUERY->param('filename2');
		$filename2 = lc($P{'filename2'});
		$filename2 =~ s!^.*(\\|\/)!!; 
		open(OUT, ">$AttachSharedDir$DirSeparator$filename2") || print &HoldError("can not save file <i>'$AttachSharedDir$DirSeparator$filename2'</i>");
		binmode OUT;
		while (read($filehandle2, $buffer, 1024)) { print OUT $buffer; }
		close OUT;
		push (@files, "$AttachSharedDir$DirSeparator$filename2");
	}
	if ($P{'filename3'})
	{
		$filehandle3 = $MULTIPARTQUERY->param('filename3');
		$filename3 = lc($P{'filename3'});
		$filename3 =~ s!^.*(\\|\/)!!; 
		open(OUT, ">$AttachSharedDir$DirSeparator$filename3") || print &HoldError("can not save file <i>'$AttachSharedDir$DirSeparator$filename3'</i>");
		binmode OUT;
		while (read($filehandle3, $buffer, 1024)) { print OUT $buffer; }
		close OUT;
		push (@files, "$AttachSharedDir$DirSeparator$filename3");
	}
	$P{'files'} = join ("\0", ($P{'files'}, @files));
	$P{'dname'} = 'Dispatch '.$nowtime, if! $P{'dname'};
	print &Operation("save dispatch <i>'$P{'dname'}'</i>".(($P{'start'})?(' and start delivery'):('')));
	$dispatch = qq{MID\254$P{'mid'}\255STATEMENT\254$P{'statement'}\255QUERY\254$P{'qid'}\255SUBJECT\254$P{'subject'}$sr\255FROMEMAIL\254$P{'fromemail'}\255RETURNPATH\254$P{'returnpath'}\255MAILHEADERS\254$P{'mailheaders'}\255HTML\254$P{'html'}\255FILES\254$P{'files'}\255ENCODING\254$P{'encoding'}\255PRIORITY\254$P{'priority'}\255BODY\254$P{'body'}$sr\255};
	$MLDBH -> do('insert into _iml_dispatches (dname, dispatch, dstart) values ('.$MLDBH->quote($P{'dname'}).','.$MLDBH->quote($dispatch).",'$P{'dstart'}')");
	$sth = $MLDBH->prepare('select did from _iml_dispatches where dname='.$MLDBH->quote($P{'dname'})); $sth -> execute(); ($did) = $sth->fetchrow_array();
	if ($P{'start'})
	{
		$code = &StartDispatch($did);
		print &HoldError($code) if $code;
	}
	print &VeiwDispatches();
}
elsif ($P{'todo'} eq 'startdispatch' and $P{'did'})
{
	$sth = $MLDBH->prepare("select dname from _iml_dispatches where did=$P{'did'}"); $sth -> execute(); ($dname) = $sth->fetchrow_array();
	print &Operation("start dispatch <i>'$dname'</i>");
	$code = &StartDispatch($P{'did'});
	print &HoldError($code) if $code;
	print &VeiwDispatches();
}
elsif ($P{'todo'} eq 'viewdispatches' or $P{'from'} eq 'viewdispatches')
{
	print &VeiwDispatches();
}
####### messages
elsif ($P{'todo'} eq 'preparemessage' or $P{'from'} eq 'preparemessage')
{
	print &SendForm($P{'eid'});
}
elsif ($P{'todo'} eq 'deletemessages' and $P{'eid'})
{
	print &Operation('delete selected messages templates');
	$eids = $P{'eid'};
	$eids =~ s/\0/\,/g;
	$MLDBH -> do("delete from _iml_emails where eid in ($eids)");
	print &MessagesList();
}
elsif ($P{'todo'} eq 'updatemessage' and $P{'eid'} and $P{'ename'} and $P{'etext'} and $P{'mid'})
{
	$P{'ehtml'} = 0 if !$P{'ehtml'};
	print &Operation("change message template <i>'$P{'ename'}'</i>");
	$MLDBH -> do('update _iml_emails set ename = '.$MLDBH->quote($P{'ename'}).', etext = '.$MLDBH->quote($P{'etext'}).", emid = $P{'mid'}, ehtml = '$P{'ehtml'}' where eid = $P{'eid'}");
	print &MessagesList();
}
elsif (($P{'todo'} eq 'editmessage' or $P{'from'} eq 'editmessage') and $P{'eid'})
{
	print &EditMessageForm($P{'eid'});
}
elsif ($P{'todo'} eq 'addmessage' and $P{'ename'} and $P{'etext'} and $P{'mid'})
{
	$P{'ehtml'} = 0 if !$P{'ehtml'};
	print &Operation("add message template <i>'$P{'ename'}'</i>");
	$MLDBH -> do("insert into _iml_emails (emid, ename, etext, ehtml) values ($P{'mid'},".$MLDBH->quote($P{'ename'}).','.$MLDBH->quote($P{'etext'}).",'$P{'ehtml'}')");
	print &MessagesList();
}
elsif ($P{'todo'} eq 'viewmessages' or $P{'from'} eq 'viewmessages')
{
	print &MessagesList();
}
####### files lists
elsif ($P{'todo'} eq 'deletefiles' and $P{'files'})
{
	if ($P{'mid'} =~ /\d+/)	{	$sth = $MLDBH->prepare("select mname, mdir from _iml_mlists where mid=$P{'mid'}"); $sth -> execute(); ($mname, $mdir) = $sth->fetchrow_array(); }
	else {$mname = 'Shared directory'; $mdir = "$AttachSharedDir"}
	print &Operation("delete selected files of  maillist <i>'$mname'</i>");
	foreach $file(split(/\0/, $P{'files'})) { if (-e "$mdir$DirSeparator$file") { unlink ("$mdir$DirSeparator$file") || print &HoldError("can not delete file <i>'$mdir$DirSeparator$file'</i>") }; }
	print &FileList($mname, $mdir, $P{'mid'});
	print &Directories();
}
elsif ($P{'todo'} eq 'uploadfile' and $P{'filename'})
{
	if ($P{'mid'} =~ /\d+/)	{	$sth = $MLDBH->prepare("select mname, mdir from _iml_mlists where mid=$P{'mid'}"); $sth -> execute(); ($mname, $mdir) = $sth->fetchrow_array(); }
	else {$mname = 'Shared directory'; $mdir = "$AttachSharedDir"}
	print &Operation("upload file for maillist <i>'$mname'</i>");
	$filehandle = $MULTIPARTQUERY->param('filename');
	$filename = lc($P{'filename'});
	$filename =~ s!^.*(\\|\/)!!; 
	open(OUT, ">$mdir$DirSeparator$filename") || print &HoldError("can not save file <i>'$mdir$DirSeparator$filename'</i>");
	binmode OUT;
	while (read($filehandle, $buffer, 1024)) { print OUT $buffer; }
	close OUT;
	print &FileList($mname, $mdir, $P{'mid'});
	print &Directories();
}
elsif ($P{'todo'} eq 'filelist' or $P{'from'} eq 'filelist')
{
	if ($P{'mid'} =~ /\d+/)	{	$sth = $MLDBH->prepare("select mname, mdir from _iml_mlists where mid=$P{'mid'}"); $sth -> execute(); ($mname, $mdir) = $sth->fetchrow_array(); }
	else {$mname = 'Shared directory'; $mdir = "$AttachSharedDir"}
	print &FileList($mname, $mdir, $P{'mid'});
	print &Directories();
}
elsif ($P{'todo'} eq 'viewfiles')
{
	print &Directories();
}
####### search subscribers, delete and edit +disable and enable
elsif ($P{'todo'} eq 'disableusers' and $P{'uid'})
{
	print &Operation('disable selected subscribers');
	$uids = $P{'uid'};
	$uids =~ s/\0/\,/g;
	$MLDBH -> do("update _iml_users set uact = '0' where uid in ($uids)");
	print &UsersList();
}
elsif ($P{'todo'} eq 'enableusers' and $P{'uid'})
{
	print &Operation('enable selected subscribers');
	$uids = $P{'uid'};
	$uids =~ s/\0/\,/g;
	$MLDBH -> do("update _iml_users set uact = '1' where uid in ($uids)");
	print &UsersList();
}
elsif ($P{'todo'} eq 'delusers' and $P{'uid'})
{
	print &Operation('delete selected subscribers');
	$uids = $P{'uid'};
	$uids =~ s/\0/\,/g;
	$MLDBH -> do("delete from _iml_users where uid in ($uids)");
	$MLDBH -> do("delete from _iml_members where muid in ($uids)");
	print &UsersList();
}
elsif ($P{'todo'} eq 'updateuser' and $P{'uname'} and $P{'uemail'} and $P{'uid'})
{
	print &Operation("change subscriber <i>'$P{'uname'}&#60;$P{'uemail'}&#62;'</i>");
	if (&CheckEmail($P{'uemail'}))
	{
		$P{'uact'} = 0 if !$P{'uact'};
		$MLDBH -> do('update _iml_users set uname = '.$MLDBH->quote($P{'uname'}).', uemail = '.$MLDBH->quote($P{'uemail'}).", uact = '$P{'uact'}', uinfo = ".$MLDBH->quote($P{'uinfo'}).", subscribed = '$P{'subscribed'}' where uid = $P{'uid'}");
		$MLDBH -> do("delete from _iml_members where muid = $P{'uid'}");
		foreach $mid(split (/\0/, $P{'mid'})) { $MLDBH -> do("insert into _iml_members (mmid, muid) values ($mid, $P{'uid'})"); }
	}
	else { print &HoldError("bad email address <i>'$P{'uemail'}'</i>. subscriber not changed."); }
	print &UsersList();
}
elsif ($P{'todo'} eq 'edituser' and $P{'uid'})
{
	print &EditUserForm($P{'uid'});
}
elsif ($P{'todo'} eq 'findusers')
{
	print &SearchResults();
	print &UsersList();
}
elsif ($P{'todo'} eq 'viewusers' or ($P{'from'} eq 'viewusers'))
{
	print &UsersList();
}
####### add subscribers
elsif ($P{'todo'} eq 'addusers' and (($P{'uname'} and $P{'uemail'}) or $P{'uemails'}))
{
	$P{'sname'}?($defaultname = $P{'sname'}):($defaultname = 'Subsciber');
	$P{'uact'} = 0 if !$P{'uact'};
	# names & emails
	if ($P{'uname'} and $P{'uemail'})
	{
		if (&CheckEmail($P{'uemail'})) { $P{'uname'} =~ s!("|')!!g; push (@unames, $P{'uname'}); push (@uemails, $P{'uemail'}) }
		else { $bademails .= "$P{'uemail'}, " }
	}
	foreach $line(split(/\n/, $P{'uemails'}))
	{
		if ($line =~ /^(.*)<([^<>]*)>$/) { if (&CheckEmail($2)) { my ($uname, $uemail) = ($1, $2); $uname =~ s!("|')!!g; push (@unames, $uname);	push (@uemails, $uemail) } else { $bademails .= "$uemail, " } }
		else { if (&CheckEmail($line)) { push (@unames, $defaultname);	push (@uemails, $line) } else { $bademails .= "$line, " } }
	}
	for ($i = 0; $i <= $#unames; ++$i) { $MLDBH -> do('insert into _iml_users (uname, uemail, uact, subscribed, uinfo) values ('.$MLDBH->quote($unames[$i]).','.$MLDBH->quote($uemails[$i]).", '$P{'uact'}', NOW(), ".$MLDBH->quote($P{'uinfo'}).')'); }
	# users ids
	$emails = join ('\',\'', @uemails);
	$sth = $MLDBH->prepare("select uid from _iml_users where uemail in ('$emails')");
	$sth -> execute();
	print &Operation('add '.$sth->rows().' subscribers');
	print &HoldError("bad emails skiped: $bademails") if $bademails;
	while (($uid) = $sth->fetchrow_array())
	{ foreach $mid(split (/\0/, $P{'mid'})) { $MLDBH -> do("insert into _iml_members (mmid, muid) values ($mid, $uid)"); } }
	print &AddUsersForm();
}
elsif ($P{'todo'} eq 'addusersform' or $P{'from'} eq 'addusers')
{
	print &AddUsersForm();
}
####### maillists
elsif ($P{'todo'} eq 'createlist' and $P{'mname'} and $P{'mdir'} and $P{'fromemail'})
{
	print &Operation(qq{create mailling list <i>'$P{'mname'}'</i>});
	$MLDBH -> do('insert into _iml_mlists (mname, mdir, memail) values ('.$MLDBH->quote($P{'mname'}).','.$MLDBH->quote($P{'mdir'}).','.$MLDBH->quote($P{'fromemail'}).')');
	print &Mlists();
}
elsif ($P{'todo'} eq 'updatelist' and $P{'mname'} and $P{'mdir'} and $P{'mid'} and $P{'fromemail'})
{
	print &Operation(qq{change mailling list <i>'$P{'mname'}'</i>});
	$MLDBH -> do('update _iml_mlists set mname = '.$MLDBH->quote($P{'mname'}).', mdir = '.$MLDBH->quote($P{'mdir'}).', memail = '.$MLDBH->quote($P{'fromemail'})." where mid = $P{'mid'}");
	print &Mlists();
}
elsif ($P{'todo'} eq 'deletelist' and $P{'mid'})
{
	print &Operation(qq{delete selected mailling lists});
	$mids = $P{'mid'};
	$mids =~ s/\0/\,/g;
	$MLDBH -> do("delete from _iml_mlists where mid in ($mids)");
	$MLDBH -> do("delete from _iml_members where mmid in ($mids)");
	$MLDBH -> do("delete from _iml_emails where emid in ($mids)");
	print &Mlists();
}
elsif ($P{'todo'} eq 'editlist' and $P{'mid'})
{
	$sth = $MLDBH->prepare("select mname, memail, mdir from _iml_mlists where mid=$P{'mid'}");
	$sth -> execute();
	($mname, $memail, $mdir) = $sth->fetchrow_array();
	print &Header(qq{Edit mailling list <i>'$mname'</i>});
	print qq{<form action="intuitive.cgi" method="post">
	<input type="hidden" name="todo" value="updatelist">
	<input type="hidden" name="mid" value="$P{'mid'}">
	<i>maillist name:</i><br>
	<input type="text" name="mname" size="50" value="$mname" style="width:350px;"><br>
	<i>default from email:</i><br>
	<input type="text" name="fromemail" size="50" value="$memail" style="width:350px;"><br>
	<i>name of directory for storing attachments:</i><br>
	<input type="text" name="mdir" value="$mdir" size="50" style="width:350px;"><br><br>
	<table width="350" border="0" cellspacing="0" cellpadding="0"><tr>
	<td><input type="submit" value="Change maillist"></td>
	<td align="right"><input type="button" value="Delete maillist" onclick="self.location='intuitive.cgi?todo=deletelist&mid=$P{'mid'}'"></td>
	</tr></table>
	</form>};
}
else
{
	print &Mlists();
}

print &BottomOfPage();

#################################################################################
sub EditUserForm
{
	my ($uid) = @_;
	my ($sth, $result, $mid, $mname,$member, $uname, $uemail, $uact, $umid, $mmid, $subscribed, $uinfo) = ();
	# user info
	$sth = $MLDBH->prepare("select uname, uemail, uact, subscribed, uinfo from _iml_users where uid = $uid");
	$sth -> execute();
	($uname, $uemail, $uact, $subscribed, $uinfo) = $sth->fetchrow_array();
	# $umid - list of user mlist
	$sth = $MLDBH->prepare("select mmid from _iml_members where muid = $uid");
	$sth -> execute();
	$umid .= "$mmid\0" while ($mmid) = $sth->fetchrow_array();
	# all mlists
	$sth = $MLDBH->prepare("select mid, mname from _iml_mlists order by mid");
	$sth -> execute();
	while(($mid, $mname) = $sth->fetchrow_array())
	{ $member .= qq{<input type="checkbox" name="mid" value="$mid"}.(($umid =~ /\b$mid\b/g)?(' checked'):('')).qq{> $mname<br>}; }
	$result .= &Header('Edit subsciber').qq{<form action="intuitive.cgi" method="post" name="edituser">
	<input type="hidden" name="todo" value="updateuser">
	<input type="hidden" name="uid" value="$uid">
	<input type="hidden" name="from" value="viewusers">
	<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td valign="top" width="50%">
	<i>subscriber name:</i><br>
	<input type="text" name="uname" size="35" value="$uname"><br>
	<i>subscriber email:</i><br>
	<input type="text" name="uemail" size="35" value="$uemail"><br>
	<i>subscribed | <a href="#" onclick="SelectDate('edituser.subscribed'); return false;">select</a>:</i><br>
	<input type="text" name="subscribed" size="35" value="$subscribed"><br><br>
	<input type="checkbox" name="uact" value="1"}.($uact?(' checked'):('')).qq{> <i>subscriber(s) is active and receives emails</i>
	</td><td valign="top" width="50%">
	<i>subscriber is member of:</i><br><br>
	$member
	</td></tr></table><br>
	<i>short information about user:</i><br>
	<textarea cols="65" rows="3" name="uinfo" wrap="off" style="width: 540px;">$uinfo</textarea><br><br>
	<table width="540" border="0" cellspacing="0" cellpadding="0"><tr>
	<td><input type="submit" value="Change subscriber"></td>
	<td align="right"><input type="button" value="Delete subscriber" onclick="self.location='intuitive.cgi?todo=delusers&uid=$uid'"></td>
	</tr></table>
	
	</form>};
	return $result;
}

sub AddUsersForm
{
	my ($sth, $result, $mid, $mname,$member) = ();
	$sth = $MLDBH->prepare("select mid, mname from _iml_mlists order by mid");
	$sth -> execute();
	while(($mid, $mname) = $sth->fetchrow_array())
	{ $member .= qq{<input type="checkbox" name="mid" value="$mid"> $mname<br>}; }
	$result .= &Header('Add subscribers').qq{<form action="intuitive.cgi" method="post">
	<input type="hidden" name="todo" value="addusers">
	<input type="hidden" name="from" value="addusers">
	<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td valign="top" width="50%">
	<i>subscriber name:</i><br>
	<input type="text" name="uname" size="35"><br>
	<i>subscriber email:</i><br>
	<input type="text" name="uemail" size="35"><br><br>
	<input type="checkbox" name="uact" value="1" checked> <i>subscriber(s) is active and receives emails</i>
	</td><td valign="top" width="50%">
	<i>subscriber(s) is member of:</i><br><br>
	$member
	</td></tr></table><br>
	<i>short information about user(s):</i><br>
	<textarea cols="65" rows="3" name="uinfo" wrap="off" style="width: 540px;"></textarea><br>
	<i>or multiple add, one email address at a line<br>(for ex: Joe Smith&#60;joe\@domain.com&#62; or just joe\@domain.com)</i><br>
	<textarea cols="65" rows="5" name="uemails" wrap="off" style="width: 540px;"></textarea><br>
	<i>use <input type="text" name="sname" size="25" value="$SubscriberName"> as name for each subscriber if name is not defined</i><br><br>
	<input type="submit" value="Add subscriber(s)">
	</form>};
	return $result;
}

sub SearchResults
{
	my ($sth, $result, $statement, $uid, $uname, $uemail, $subscribed, @where, $where, $from, @uids, $found) = ();
	$from = '_iml_users';
	push (@where, "uname like '%$P{'uname'}%'") if defined $P{'uname'};
	push (@where, "uemail like '%$P{'uemail'}%'") if defined $P{'uemail'};
	push (@where, "uact = '$P{'uact'}'") if $P{'uact'} =~ /\d/;
	if ($P{'limit1'} =~ /\d+/ and $P{'limit2'} =~ /\d+/) { my($limit1) = $P{'limit1'}-1; my($limit2) = $P{'limit2'}-$limit1; $limit = "limit $limit1,$limit2";}
	if ($P{'mid'} =~ /\d+/)
	{
		$from .= ', _iml_members' ;
		push (@where, "uid = muid");
		push (@where, "mmid = $P{'mid'}");
	}
	elsif ($P{'mid'} eq '-')
	{
		$from .= ' left join _iml_members on uid = muid' ;
		push (@where, "mmid is NULL");
	}
	if ($P{'dt'} eq 'earlier')
	{
		push (@where, "DATE_FORMAT(subscribed,'%Y%m%d%H%i%S') <= DATE_FORMAT('$P{'datetime'}','%Y%m%d%H%i%S')");
	}
	elsif ($P{'dt'} eq 'later')
	{
		push (@where, "DATE_FORMAT(subscribed,'%Y%m%d%H%i%S') >= DATE_FORMAT('$P{'datetime'}','%Y%m%d%H%i%S')");
	}
	$where = 'where '.join (' and ', @where) if @where;
	$P{'orderby'} = 'subscribed' if !$P{'orderby'};
	$statement = qq{ select distinct uname, uemail, uid, DATE_FORMAT(subscribed,'%d %M %Y'), uact from $from $where order by $P{'orderby'}}.(($P{'desc'})?(' desc'):(''));
	$sth = $MLDBH->prepare("$statement $limit");
	$sth -> execute();
	$found = $sth -> rows();
	$result .= &Header("Search results ($found subscribers found)");
	if ($found)
	{
		$result .= qq{
		<form action="intuitive.cgi" method="post" name="searchresults" onsubmit="return SelectStatement()">
		<input type="hidden" name="from" value="viewusers"><ul>
		<input type="hidden" name="statement" value="$statement">};
		while(($uname, $uemail, $uid, $subscribed, $uact) = $sth->fetchrow_array())
		{ $result .= qq{<li> <input type="checkbox" name="uid" value="$uid" title="select for delete"> <a href="intuitive.cgi?todo=edituser&uid=$uid" title="edit subscriber">$uname&#60;$uemail&#62;</a> ($subscribed | }.(($uact)?('enabled'):('disabled')).')'; }
		$result .= q{</ul><input type="checkbox" onclick="for (var i=0;i<searchresults.elements.length;i++) { var z=searchresults.elements[i]; if (z.name == 'uid') { z.checked = !z.checked } }"> invert selection<br><br>

		<input type="radio" name="todo" value="delusers" onclick="searchresults.submit.value = 'Delete selected'; searchresults.submit.disabled = false;"> delete selected subscribers<br>
		<input type="radio" name="todo" value="disableusers" onclick="searchresults.submit.value = 'Disable selected'; searchresults.submit.disabled = false;"> disable selected subscribers<br>
		<input type="radio" name="todo" value="enableusers" onclick="searchresults.submit.value = 'Enable selected'; searchresults.submit.disabled = false;"> enable selected subscribers<br>
		<hr size="1" noshade>
		<input type="radio" name="todo" value="viewmessages" onclick="searchresults.submit.value = 'Mail to selected'; searchresults.submit.disabled = false;"> send message to selected subscribers<br>
		<input type="radio" name="todo" value="viewmessages" onclick="searchresults.submit.value = 'Mail to results'; searchresults.submit.disabled = false;" title="This will use all search results for message delivery and ignore search results limits you specified"> send message to all subscribers from search results<br>
		<hr size="1" noshade>
		<input type="radio" name="todo" value="downloadsearch" onclick="searchresults.submit.value = 'Export search results'; searchresults.submit.disabled = false;"> export all mail addresses from search results<br><br>
		<input type="submit" name="submit" value="First select action" disabled>
		<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
		<!--
		statement1 = document.searchresults.statement.value;
		function SelectStatement()
		{
			if (document.searchresults.todo[3].checked)
			{
				var uid = '';
				for (var i=0;i<document.searchresults.elements.length;i++)
				{
					var z=document.searchresults.elements[i];
					if (z.name == 'uid' && z.checked) { uid = uid + ',' + z.value }
				}
				if (uid) { document.searchresults.statement.value = 'select uname, uemail from _iml_users where uid in (-1' + uid + ')'; return true; }
				else { alert('No subscribers selected'); return false; }
			}
			else { document.searchresults.statement.value=statement1; return true; }
		}		
		//-->
		</SCRIPT>
		</form>};
	}
	else
	{ $result .= '<ul><li>Nothing is retrieved</li></ul>'; }
	return $result;
}

sub UsersList
{
	my ($sth, $result, $mid, $mname, $notmember, $member, $uactno, $uact1, $uact0) = ();
	if ($P{'uact'} eq '1') { $uact1 = 'checked' }
	elsif ($P{'uact'} eq '0') { $uact0 = 'checked' }
	else { $uactno = 'checked' }
	$sth = $MLDBH->prepare("select mid, mname from _iml_mlists order by mid");
	$sth -> execute();
	while(($mid, $mname) = $sth->fetchrow_array())
	{ $member .= qq{<input type="radio" name="mid" value="$mid"}.(($P{'mid'} =~ /\b$mid\b/g)?(' checked'):('')).qq{> $mname<br>}; }
	$result .= &Header('Find subscribers').qq{<form action="intuitive.cgi" method="post" name="searchform">
	<input type="hidden" name="todo" value="findusers">
	<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td valign="top" width="50%">
	<i>subscriber name:</i><br>
	<input type="text" name="uname" value="$P{'uname'}" size="35"><br>
	<i>subscriber email:</i><br>
	<input type="text" name="uemail" value="$P{'uemail'}" size="35"><br><br>
	<i>subscriber is:</i><br>
	<input type="radio" name="uact" value="1" $uact1> active and receives mail<br>
	<input type="radio" name="uact" value="0" $uact0> temporarily disabled<br>
	<input type="radio" name="uact" value="" $uactno> no matter<br><br>
	<i>and subscribed</i> | <a href="#" onclick="SelectDate('searchform.datetime'); return false;">select</a>:<br>
	<input onclick="document.searchform.datetime.disabled = false;" type="radio" name="dt" value="earlier"}.(($P{'dt'} eq 'earlier')?(' checked'):('')).qq{>earlier on<br>
	<input onclick="document.searchform.datetime.disabled = false;" type="radio" name="dt" value="later"}.(($P{'dt'} eq 'later')?(' checked'):('')).qq{>later on<br>
	<input onclick="document.searchform.datetime.disabled = true;" type="radio" name="dt" value=""}.(!$P{'dt'}?(' checked'):('')).qq{>no matter<br>
	<input type="text" name="datetime" size="35" }.($P{'datetime'}?(qq{value="$P{'datetime'}"}):('value="YYYY-MM-DD HH:MM:SS" disabled')).qq{><br><br>
	</td><td valign="top" width="50%">
	<i>subscriber is member of:</i><br><br>
	<input type="radio" name="mid" value="+"}.((!$P{'mid'} or $P{'mid'} eq '+')?(' checked'):('')).qq{> Can be member of any maillist<br>
	<input type="radio" name="mid" value="-"}.(($P{'mid'} eq '-')?(' checked'):('')).qq{> Not member of any maillist<br>
	$member
	</td></tr>
	<tr><td valign="bottom"><i>Limit search results by records:</i><br>
	from: <input type="text" name="limit1" value="$P{'limit1'}" size="7"> to: <input type="text" name="limit2" value="$P{'limit2'}" size="7"> }.(($P{'limit1'} =~ /\d+/ and $P{'limit2'} =~ /\d+/)?('<a href="#" onclick="NPPages(\'-\'); return false;">&#171;prev</a>&nbsp;|&nbsp;<a href="#" onclick="NPPages(\'+\'); return false;">next&#187;</a>'):('')).qq{<br><br>
	<i>Order results by:</i>
	<select name="orderby">
		<option value="uname"}.(($P{'orderby'} eq 'uname')?(' selected'):('')).qq{>name
		<option value="uemail"}.(($P{'orderby'} eq 'uemail')?(' selected'):('')).qq{>email
		<option value="uact"}.(($P{'orderby'} eq 'uact')?(' selected'):('')).qq{>status
		<option value="subscribed"}.(($P{'orderby'} eq 'subscribed')?(' selected'):('')).qq{>date
	</select>
	<input type="checkbox" name="desc" value="1"}.(($P{'desc'})?(' checked'):('')).qq{> descending
	</td>
	<td align="center" valign="bottom"><input type="submit" value="Search" style="width:150px;"></td>
	</tr></table>
	</form>
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
		function NPPages(act)
		{
			var limit1 = document.searchform.limit1.value;
			var limit2 = document.searchform.limit2.value;
			diap = limit2 - limit1;
			if (act == '+') { limit1 = (limit1/1 + diap/1 + 1)/1; limit2 = (limit2/1 + diap/1 + 1)/1; }
			else { limit1 = limit1 - diap - 1; limit2 = limit2 - diap - 1; }
			document.searchform.limit1.value = limit1;
			document.searchform.limit2.value = limit2;
		}
	//-->
	</SCRIPT>};
	return $result;
}

sub Mlists
{
	my ($sth, $mid, $mname, $result, $nextmid, $uids) = ();
	$sth = $MLDBH->prepare("select max(mid) from _iml_mlists");
	$sth -> execute();
	($nextmid) = $sth->fetchrow_array();
	++$nextmid;
	$sth2 = $MLDBH->prepare("select count(muid) from _iml_users, _iml_mlists left join _iml_members on mmid = mid where mmid = ? and uid = muid and uact = '1' group by mid order by mid");
	$sth = $MLDBH->prepare("select mid, mname, count(muid) from _iml_mlists left join _iml_members on mmid = mid group by mid order by mid");
	$sth -> execute();
	if ($sth->rows())
	{
		$result = &Header('Mailing lists ('.$sth->rows().' maillists found)');
		$result .= '<form action="intuitive.cgi" method="post"><input type="hidden" name="todo" value="deletelist"><ul>';
		while (($mid, $mname, $uids) = $sth->fetchrow_array())
		{
			$sth2 -> execute($mid); ($uidse) = $sth2->fetchrow_array(); $uidse = 0 if !$uidse;
			$result .= qq{<li> <input type="checkbox" name="mid" value="$mid" title="select for delete"> | ID=$mid | <a href="intuitive.cgi?todo=editlist&mid=$mid" title="edit maillist">$mname</a> (}
			.(($uids)
			?(qq{<a href="intuitive.cgi?todo=findusers&mid=$mid&uact=1" title="show enabled subscribers">$uidse</a>/<a href="intuitive.cgi?todo=findusers&mid=$mid&uact=0" title="show disabled subscribers">}.($uids-$uidse).qq{</a> of <a href="intuitive.cgi?todo=findusers&mid=$mid" title="show all subscribers">$uids</a> subscribers})
			:("$uids subscribers"))
			.')';
		}
		$result .= '</ul><input type="submit" value="Delete selected"></form>';
	}
	$result .= &Header('Create new mailing list');
	$result .= qq{<form action="intuitive.cgi" method="post">
	<input type="hidden" name="todo" value="createlist">
	<i>maillist name:</i><br>
	<input type="text" name="mname" size="50" style="width:350px;"><br>
	<i>default from email:</i><br>
	<input type="text" name="fromemail" size="50" value="$FromEmail" style="width:350px;"><br>
	<i>name of directory for storing attachments:</i><br>
	<input type="text" name="mdir" value="$AttachDir$DirSeparator}."maillist_$nextmid".qq{" size="50" style="width:350px;"><br><br>
	<input type="submit" value="Create maillist">
	</form>};
	return $result;
}

sub FileList()
{
	my ($mname, $mdir, $mid) = @_;
	my ($result, $file, $files, $dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = ();
	local *DIR;
	mkdir ("$mdir", 0777);
	opendir (DIR, "$mdir");
	while ($file = readdir(DIR))
	{
		($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$mdir$DirSeparator$file");
		$mtime = TextDateTime($mtime);
		$files .= qq{<li><input type="checkbox" name="files" value="$file" title="select for delete"> $file <i>($mtime; size: $size bytes)</i>} if ($file ne '.' and $file ne '..')
	}
	closedir(DIR);
	$result .= &Header("Files for maillist <i>'$mname'</i>").qq{<form action="intuitive.cgi" method="post"><input type="hidden" name="from" value="filelist"><input type="hidden" name="todo" value="deletefiles"><input type="hidden" name="mid" value="$mid"><ul>$files</ul><input type="submit" value="Delete selected"></form>} if $files;
	$result .= &Header("Upload file for mailing list <i>'$mname'</i>").qq{<form action="intuitive.cgi" method="post" enctype="multipart/form-data">
	<input type="hidden" name="from" value="filelist">
	<input type="hidden" name="todo" value="uploadfile">
	<input type="hidden" name="mid" value="$mid">
	<input type="file" name="filename" size="50"><br><br>
	<input type="submit" value="Upload file">
	</form>};
	return $result;
}

sub Directories
{
	my ($sth, $mid, $mname, $result) = ();
	$result = &Header('Select mailling list');
	$result .= '<ul>';
	$sth = $MLDBH->prepare("select mid, mname from _iml_mlists order by mid");
	$sth -> execute();
	while (($mid, $mname) = $sth->fetchrow_array())
	{ $result .= qq{<li> <a href="intuitive.cgi?todo=filelist&mid=$mid" title="veiw files for maillist '$mname'">$mname</a>}; }
	$result .= q{<li> <a href="intuitive.cgi?todo=filelist&mid=-" title="veiw shared files for all maillists">Shared directory</a>};
	$result .= '</ul>';
	return $result;
}

sub MessagesList
{
	my ($mlists, $sth, $sth2, $eid, $ename, $mid, $mname, $result, $found, $eids) = ();
	$P{'statement'} =~ s/\'/\\'/g;
	$result .= &Header('Create and run dispatch quickly').qq{<ul><li> <i>Prepare</i><li> <input type="radio" name="edit" title="click to prepare message for send" onclick="self.location='intuitive.cgi?todo=preparemessage&eid=0&statement=$P{'statement'}&qid=$P{'qid'}'"> Create and run dispatch without creating a template</ul>};
	$sth = $MLDBH->prepare("select count(eid) from _iml_emails");
	$sth -> execute();
	($eids) = $sth->fetchrow_array();
	$sth = $MLDBH->prepare("select mid, mname from _iml_mlists order by mid");
	$sth -> execute();
	if ($sth->rows())
	{
		$result .= '<form action="intuitive.cgi" method="post"><input type="hidden" name="todo" value="deletemessages"><input type="hidden" name="from" value="viewmessages">' if $eids;
		while (($mid, $mname) = $sth->fetchrow_array())
		{
			$mlists .= qq{<option value="$mid">$mname</option>};
			$sth2 = $MLDBH->prepare("select eid, ename from _iml_emails where emid = $mid order by eid");
			$sth2 -> execute();
			$found = $sth2 -> rows();
			if ($found)
			{
				$result .= &Header("Messages templates for mailing list <i>'$mname'</i> ($found found)");
				$result .= '<ul>';
				$result .= '<li> <i>Del</i> | <i>Prepare</i>';
				while (($eid, $ename) = $sth2->fetchrow_array())
				{ $result .= qq{<li> <input type="checkbox" name="eid" value="$eid" title="select for delete"> | <input type="radio" name="edit" title="click to prepare message for send" onclick="self.location='intuitive.cgi?todo=preparemessage&eid=$eid&statement=$P{'statement'}&qid=$P{'qid'}'"> | <a href="intuitive.cgi?todo=editmessage&eid=$eid" title="edit message template">$ename</a>}; }
				$result .= '</ul>';
			}
		}
		$result .= '<input type="submit" value="Delete selected"></form>' if $eids;
	}
	# external messages	
	if (!$pop3error and $ExtMessagesHost and $ExtMessagesLogin and $ExtMessagesPass)
	{
		$result .= &Header("Messages created in your favorite mail program");
		$pop = new Mail::POP3Client(HOST=>"$ExtMessagesHost", AUTH_MODE=>"PASS", DEBUG=>'0');
		$pop->User("$ExtMessagesLogin");
		$pop->Pass("$ExtMessagesPass");
		$pop->Connect();
		if ($pop->Message() =~ /^\+OK/i)
		{
			$result .= '<form action="intuitive.cgi" method="post"><input type="hidden" name="todo" value="deletepop3messages"><input type="hidden" name="from" value="viewmessages"><ul>';
			if (!$pop->Count()) { $result .= '<li> No prepared messages'; } else { $result .= '<li> <i>Del</i> | <i>Prepare</i>'; }
			for($i = 1; $i <= $pop->Count(); $i++)
			{
				my $subject = '[no subject]';
				foreach ($pop->Head($i)) { /^Subject:\s+(.*)/i && ($subject = $1) }
				$result .= qq{<li> <input type="checkbox" name="pop3id" value="$i" title="select for delete"> | <input type="radio" name="edit" title="click to prepare message for send" onclick="self.location='intuitive.cgi?todo=preparemessage&pop3id=$i&statement=$P{'statement'}&qid=$P{'qid'}'"> | $subject}; 
			}
			$result .= '</ul>'.(($pop->Count())?('<input type="submit" value="Delete selected">'):('')).'</form>';
			$pop->Close();
		}
		else { $result .= &HoldError('POP auth: '.$pop->Message()); }
	}
	$result .= &Header('Add new message template').qq{<form action="intuitive.cgi" method="post" name="addtemplateform">
	<input type="hidden" name="todo" value="addmessage">
	<input type="hidden" name="from" value="viewmessages">
	<i>select mailling list:</i><br>
	<select name="mid" style="width: 420px;">$mlists</select><br>
	<i>message subject:</i><br>
	<input type="text" name="ename" size="50" style="width: 420px;"><br>
	<i>message template (insert subscribers <a href="#" onclick="InsertKey(document.addtemplateform.etext,'%name%'); return false;">name</a> or <a href="#" onclick="InsertKey(document.addtemplateform.etext,'%email%'); return false;">email</a>):</i><br>
	<textarea cols="39" rows="10" name="etext" style="width: 420px;" wrap="off"></textarea><br>
	<input type="checkbox" name="ehtml" value="1"> <i>this is a html formated message</i> | <a href="#" onclick="HTMLPreview(document.addtemplateform.etext.value, document.addtemplateform.ehtml.checked, 'addtemplateform.etext'); return false;">preview or edit</a><br><br>
	<input type="submit" value="Add template">
	</form>};
	return $result;
}

sub EditMessageForm
{
	my ($eid) = @_;
	my ($mlists, $sth, $ename, $mid, $mname, $emid, $etext, $result, $ehtml) = ();
	$sth2 = $MLDBH->prepare("select ename, etext, emid, ehtml from _iml_emails where eid = $eid");
	$sth2 -> execute();
	($ename, $etext, $emid, $ehtml) = $sth2->fetchrow_array();
	$sth = $MLDBH->prepare("select mid, mname from _iml_mlists order by mid");
	$sth -> execute();
	while (($mid, $mname) = $sth->fetchrow_array())
	{ $mlists .= qq{<option value="$mid"}.(($mid == $emid)?(' selected style="background-color: #FFFFFF;"'):('')).qq{>$mname</option>}; }
	$result = &Header("Edit message template <i>'$ename'</i>").qq{<form action="intuitive.cgi" method="post" name="editmessageform">
	<input type="hidden" name="todo" value="updatemessage">
	<input type="hidden" name="from" value="editmessage">
	<input type="hidden" name="eid" value="$eid">
	<i>select mailling list:</i><br>
	<select name="mid" style="width: 420px; background-color: #E0E0E0;">$mlists</select><br>
	<i>message subject:</i><br>
	<input type="text" name="ename" size="50" style="width: 420px;" value="$ename"><br>
	<i>message template (insert subscribers <a href="#" onclick="InsertKey(document.editmessageform.etext,'%name%'); return false;">name</a> or <a href="#" onclick="InsertKey(document.editmessageform.etext,'%email%'); return false;">email</a>):</i><br>
	<textarea cols="39" rows="10" name="etext" style="width: 420px;" wrap="off">$etext</textarea><br>
	<input type="checkbox" name="ehtml" value="1"}.($ehtml?(' checked'):('')).qq{> <i>this is a html formated message</i> | <a href="#" onclick="HTMLPreview(document.editmessageform.etext.value, document.editmessageform.ehtml.checked, 'editmessageform.etext'); return false;">preview or edit</a><br><br>
	<table width="420" border="0" cellspacing="0" cellpadding="0"><tr>
	<td><input type="submit" value="Change template"></td>
	<td align="right"><input type="button" value="Delete template" onclick="self.location='intuitive.cgi?todo=deletemessages&eid=$eid'"></td>
	</tr></table>
	</form>};
	return $result;
}

sub SendForm
{
	my ($eid) = @_;
	my ($sth, $result, $ename, $etext, $emid, $mid, $mname, $ehtml, $mdir, $mdir2, $attach, $mlists, $sharedattach, $memail, $memail2, $headers, $encoding, $file, $dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = ();
	# message from DB or quick
	if ($eid =~ /\d+/)
	{
		$sth = $MLDBH->prepare("select ename, etext, emid, ehtml from _iml_emails where eid=$P{'eid'}");
		$sth -> execute();
		($ename, $etext, $emid, $ehtml) = $sth->fetchrow_array();
		($ename, $etext, $emid, $ehtml) = ('Quick dispatch', 'Type your message here', 0, 0) if !$sth->rows();
	}
	# pop3 message
	else 
	{
		($emid, $ehtml) = ('0', '0');
		$MailHeaders = '';
		$pop = new Mail::POP3Client(HOST=>"$ExtMessagesHost", AUTH_MODE=>"PASS", DEBUG=>'0');
		$pop->User("$ExtMessagesLogin");
		$pop->Pass("$ExtMessagesPass");
		$pop->Connect();
		if ($pop->Message() =~ /^\+OK/i)
		{
			$ename = '[no subject]';
			my ($flag) = '';
			foreach ($pop->Head($P{'pop3id'}))
			{
				/^Subject:\s+(.*)/i && ($ename = $1);
				if ($_ =~ /^(Content-Type:|MIME-Version:)/i) { $MailHeaders .= "$_\n"; $flag = 1 }
				elsif ($_ =~ /^\t+/ and $flag) { s/\t/ /g; chop $MailHeaders; $MailHeaders .= "$_\n"; $flag = 1 }
				else { $flag = '' }
			};
		  $etext = $pop->Body($P{'pop3id'});
			$pop->Close();
		}
		else { $result .= &HoldError('POP auth: '.$pop->Message()); }
	}
	# mail headers
	if ($MailHeaders)
	{
		grep($headers .= qq{<li> <input type="checkbox" name="mailheaders" value='$_' checked> $_}, split(/\n/, $MailHeaders));
		$headers = qq{<i>messages headers:</i><br><ul>$headers</ul>};
	}
	# encoding
	if ($Convert1 and $Convert2) { $encoding = qq{<input type="checkbox" name="encoding" value="1"}.(($P{'pop3id'})?(''):(' checked')).qq{> <i>use character encoding at dispatch of the messages</i><br><br>}; }
	# priority
	$priority = qq{<i>messages priority:</i> <select name="priority"><option value="2 (High)">High<option value="3 (Normal)" selected>Normal<option value="4 (Low)">Low</select><br><br>};
	$sth = $MLDBH->prepare("select mid, mname, memail, mdir from _iml_mlists order by mid");
	$sth -> execute();
	while(($mid, $mname, $memail2, $mdir2) = $sth->fetchrow_array())
	{
		if ($mid == $emid) { $mdir = $mdir2; $memail = $memail2 }
		$mlists .= qq{<li> <input type="checkbox" name="mid" value="$mid"}.(($mid == $emid)?(' checked'):('')).qq{> | $mname}.(($mid == $emid)?(' (default)'):(''));
	}
	$memail = $FromEmail if !$memail;
	opendir (DIR, $AttachSharedDir);
	while ($file = readdir(DIR))
	{
		($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$AttachSharedDir$DirSeparator$file");
		$mtime = TextDateTime($mtime);
		$sharedattach .= qq{<li><input type="checkbox" name="files" value="$AttachSharedDir$DirSeparator$file"> $file <i>($mtime; size: $size bytes)</i>} if ($file ne '.' and $file ne '..')
	}
	closedir(DIR);
	if ($mdir)
	{
		opendir (DIR, "$mdir");
		while ($file = readdir(DIR))
		{
			($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$mdir$DirSeparator$file");
			$mtime = TextDateTime($mtime);
			$attach .= qq{<li><input type="checkbox" name="files" value="$mdir$DirSeparator$file"> $file <i>($mtime; size: $size bytes)</i>} if ($file ne '.' and $file ne '..')
		}
		closedir(DIR);
	}
	$attach = '<li> no files found' if !$attach;
	$sharedattach =  '<li> no files found' if !$sharedattach;
	$result .= &Header("Prepare message <i>'$ename'</i> for send".
	(($P{'statement'} or $P{'qid'})
	?(qq{ to subscribers from search results or SQL query})
	:('')))
	.qq{<form action="intuitive.cgi" name="dispatch" method="post" enctype="multipart/form-data">
	<input type="hidden" name="todo" value="savedispatch">
	<input type="hidden" name="from" value="preparemessage">
	<input type="hidden" name="eid" value="$eid">
	<input type="hidden" name="pop3id" value="$P{'pop3id'}">
	<i>send messages from:</i><br>
	<input type="text" name="fromemail" value="$memail" size="50" style="width: 420px;"><br>
	<i>Return-Path:</i><br>
	<input type="text" name="returnpath" value="$ReturnPath" size="50" style="width: 420px;"><br><br>}.
	(($P{'statement'} or $P{'qid'})
	?(qq{<input type="hidden" name="statement" value="$P{'statement'}"><input type="hidden" name="qid" value="$P{'qid'}">})
	:("<i>send messages to subscribers from maillists:</i><br><ul>$mlists</ul>"))
	.qq{
	$headers
	$priority
	<i>messages subject:</i><br>
	<input type="text" name="subject" value="$ename" size="50" style="width: 420px;"><br>
	<i>messages body (insert subscribers <a href="#" onclick="InsertKey(document.dispatch.body,'%name%'); return false;">name</a> or <a href="#" onclick="InsertKey(document.dispatch.body,'%email%'); return false;">email</a>):</i><br>
	<textarea cols="39" name="body" style="width: 420px;" wrap="off"}.(($P{'pop3id'})?(' readonly rows="3" title="you can not change body of the message received from mailbox"'):(' rows="10"')).qq{>$etext</textarea><br>
	<input type="checkbox" name="html" value="1"}.(($P{'pop3id'})?(' disabled'):('')).($ehtml?(' checked'):('')).qq{> <i>this is a html formated message</i> | <a href="#" onclick="HTMLPreview(document.dispatch.body.value, document.dispatch.html.checked, 'dispatch.body'); return false;">preview or edit</a><br><br>}
	.(($P{'pop3id'})
	?('')
	:(qq{
		<i>attach files:</i><br>
		<ul>$attach</ul>
		<i>attach shared files:</i><br>
		<ul>$sharedattach</ul>
		<i>or upload files for attach:</i><br>
		<input type="file" name="filename1" size="50" style="width: 420px;"><br>
		<input type="file" name="filename2" size="50" style="width: 420px;"><br>
		<input type="file" name="filename3" size="50" style="width: 420px;"><br><br>
	})).qq{
	$encoding
	<input type="radio" name="start" value="1" onclick="CheckStart()"}.(($DelayDelivery)?(''):(' checked')).qq{> <i>Save dispatch in dispatches lists and start delivery.<br>
	<input type="radio" name="start" value="0" onclick="CheckStart()"}.(($DelayDelivery)?(' checked'):('')).qq{> <i>Save dispatch in dispatches lists for future delivery.<br>
	name of dispatch:</i><br><input type="text" name="dname" size="50" value="Saved at }.&TextDateTime(time).qq{" disabled><br>
	start after | <a href="#" onclick="SelectDate('dispatch.dstart'); return false;">select</a>:</i><br><input type="text" name="dstart" size="50" value="1970-01-01 00:00:00" disabled><br><br>
	<input type="submit" name="submit" value="Save dispatch and start delivery">
	</form>
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
  <!--
	function CheckStart()
	{
		if (document.dispatch.start[0].checked) { document.dispatch.submit.value = 'Save dispatch and start delivery'; document.dispatch.dname.disabled = true; document.dispatch.dstart.disabled = true; }
		else { document.dispatch.submit.value = 'Save dispatch for future delivery'; document.dispatch.dname.disabled = false; document.dispatch.dstart.disabled = false; }
	}
  CheckStart();
  //-->
  </SCRIPT>
	};
	return $result;
}

sub EditQueryForm
{
	my ($qid) = @_;
	my ($result, $sth, $qname, $qdbi, $qstatement) = ();
	$result .= &Header("Edit SQL query");
	$sth = $MLDBH->prepare("select qname, qdbi, qstatement from _iml_queries where qid=$qid");
	$sth -> execute();
	($qname, $qdbi, $qstatement) = $sth->fetchrow_array();
	$qdbi =~ s/"/&quot;/g;
	$result .= qq{<form action="intuitive.cgi" method="post">
	<input type="hidden" name="qid" value="$qid">
	<input type="hidden" name="todo" value="updatequery">
	<input type="hidden" name="from" value="editquery">
	<i>query name:</i><br>
	<input type="text" name="qname" value="$qname" size="50" style="width: 420px;"><br>
	<i title="as appearing in DBI->connect()">data source, username and password:</i><br>
	<input type="text" name="qdbi" value="$qdbi" size="50" style="width: 420px;"><br>
	<i>SQL query:</i><br>
	<input type="text" name="qstatement" value="$qstatement" size="50" style="width: 420px;"><br><br>
	<table width="420" border="0" cellspacing="0" cellpadding="0"><tr>
	<td><input type="submit" value="Change query"></td>
	<td align="right"><input type="button" value="Delete query" onclick="self.location='intuitive.cgi?todo=delqueries&qid=$qid'"></td>
	</tr></table>
	</form>};
	return $result;
}

sub VeiwQueries
{
	my ($result, $sth, $qid, $qname) = ();
	$sth = $MLDBH->prepare("select qid, qname from _iml_queries order by qid");
	$sth -> execute();
	if ($sth -> rows())
	{
		$result .= &Header("SQL queries list");
		$result .= qq{<form action="intuitive.cgi" method="post"><input type="hidden" name="todo" value="delqueries"><input type="hidden" name="from" value="viewqueries">};
		$result .= q{<ul><li> <i>Del</i> | <i>Dispatch</i>};
		while (($qid, $qname) = $sth->fetchrow_array())
		{
			$result .= qq{<li>  <input type="checkbox" name="qid" value="$qid" title="select for delete"> | <input type="radio" name="startdispatch" title="create dispath for users from SQL query" onclick="self.location='intuitive.cgi?todo=viewmessages&qid=$qid'"> | <a href="intuitive.cgi?todo=editquery&qid=$qid" title="edit query">$qname</a>};
		}
		$result .= q{</ul><input type="submit" value="Delete selected"></form>};
	}
	$result .= &Header("Add new SQL query");
	$result .= qq{<form action="intuitive.cgi" method="post">
	<input type="hidden" name="todo" value="addquery">
	<input type="hidden" name="from" value="viewqueries">
	<i>query name:</i><br>
	<input type="text" name="qname" value="" size="50" style="width: 420px;"><br>
	<i title="as appearing in DBI->connect()">data source, username and password:</i><br>
	<input type="text" name="qdbi" value="&quot;DBI:mysql:database=DBName;host=HostName&quot;,&quot;UserName&quot;,&quot;UserPassword&quot;" size="50" style="width: 420px;"><br>
	<i>SQL query:</i><br>
	<input type="text" name="qstatement" value="select name, email from subscribers" size="50" style="width: 420px;"><br><br>
	<input type="submit" value="Add query">
	</form>};
	return $result;
}

sub VeiwDispatches
{
	my ($result, $sth, $did, $dname, $delivery) = ();
	$delivery = 1 if (-e "$PIDFile");
	$result = &Header("Dispatches list");
	$sth = $MLDBH->prepare("select did, dname, dstart from _iml_dispatches order by did");
	$sth -> execute();
	if ($sth -> rows())
	{
		$result .= qq{<form action="intuitive.cgi" method="post"><input type="hidden" name="todo" value="deldispatch"><input type="hidden" name="from" value="viewdispatches">};
		$result .= q{<ul><li> <i>Del</i> | <i>Send</i>};
		while (($did, $dname, $dstart) = $sth->fetchrow_array())
		{
			$result .= qq{<li>  <input type="checkbox" name="did" value="$did" title="select for delete"> | <input type="radio" name="startdispatch" onclick="self.location='intuitive.cgi?todo=startdispatch&did=$did'"}.(($delivery)?(' disabled title="delivery in progress. please try latter"'):(' title="start delivery"')).qq{> | ID=$did | $dname (start after $dstart)};
		}
		$result .= qq{</ul><input type="submit" value="Delete selected"}.(($delivery)?(' disabled title="delivery in progress. please try latter"'):('')).'></form>';
	}
	else { $result .= '<ul><li> no dispatches created</ul>'; }
	if ($delivery)
	{
		local *PIDFILE;
		my ($status,$pid) = ();
		my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$PIDFile");
		$ctime = TextDateTime($ctime);
    if (!open(PIDFILE,$PIDFile)) { $status = 'can not open PID file' }
		else
		{
		  $pid = <PIDFILE>; close PIDFILE;
			if ($pid > 1 && kill(0,$pid)) { $status = "process with PID $pid running" }
			else { $status = "process with PID $pid is long dead" }
		}
		$result .= &Header("Delivery status");
		$result .= qq{<form action="intuitive.cgi" method="post">
		<input type="hidden" name="todo" value="killdelivery">
		<input type="hidden" name="from" value="viewdispatches">
		<input type="hidden" name="pid" value="$pid">
		<ul>
			<li>Started at: $ctime
			<li>$status
		</ul>
		<input type="submit" value="Delete PID file and kill process">
		</form>};	
	}
	return $result;
}

sub StartDispatch
{
	my ($did) = @_;
	my ($cmd) = '.'.$DirSeparator.'delivery.cgi';
	$cmd = "$^X $cmd" if $ENV{'WINDIR'};
	if (!-e "$PIDFile")
	{
		if ($DebugDelivery)
		{
			print '<pre style="font-size:11px;">';
			my $code = system("$cmd --d=$did --del 2>&1");
			print '</pre>';
			return "failed to run <i>'$cmd'</i>. $!" if $code;
		}
		else
		{
			my $code = system("$cmd --d=$did --del --quiet --fork");
			return "failed to run <i>'$cmd'</i>. $!" if $code;
		}
	}
	else { return "can not start. delivery already in progress." }
	sleep 2;
	return 0;
}

sub DBIInit()
{
	$MLDBH = DBI->connect("DBI:mysql:database=$mySQLDBName;host=$mySQLHost",$mySQLUser,$mySQLPassword);
	$dbierror = DBI->errstr;
	return if $dbierror;
	my ($pname, $pvalue) = ();
	$sth = $MLDBH->prepare("select pname, pvalue from _iml_tune");
	$sth -> execute();
	$dbierror = DBI->errstr;
	return if $dbierror;
	${$pname} = $pvalue while (($pname, $pvalue) = $sth->fetchrow_array());
	$SIG{__WARN__} = PrintError;
}

sub EditConfigForm
{
	my ($result, $params, $cfgfile, $pname, $pvalue, $porder, %params, $flag) = ();
	local *IN;
	open(IN, 'intuitive.pm') || ($cfgfile = &CfgTemplate());
	grep ($cfgfile .= $_, <IN>);
	close IN;
	if ($configerror) { $result .= &HoldError($configerror) }
	elsif ($dbierror) { $result .= &HoldError($dbierror) }
	else
	{
		# params descr		
		$params{'AttachDir'} = q{<p title="Default complete path to directory where to store files for attaching, leave out trailing \ or /">Directory for storing attachments};
		$params{'AttachSharedDir'} = q{<p title="Default complete path to directory where to store shared files for attaching in any maillist, leave out trailing \ or /">Directory with shared attachments};
		$params{'FromEmail'} = q{<p>Default email address from which emails will be send};
		$params{'ReturnPath'} = q{<p title="This work if messages send with |/usr/sbin/sendmail and may not work with SMTP servers.">Default email address (Return-Path) for undelivered messages};
		$params{'SMTP'} = q{<p title="indexsoft intuitive mailer uses sendmail.pm (http://www.tneoh.zoneit.com/perl/SendMail/) to send email if sendmail.pm can not connect to SMTP host you can use patched sendmail.pm, wich can use a program to send emails (for example sendmail for linux). In this case type in here command line and parameters of a program (for example to use linux sendmail type here: |/usr/sbin/sendmail -t); check downloads page at http://www.indexsoft.com/ to download patched sendmail.pm to install sendmail.pm you can just copy it in the same directory where indexsoft intuitive mailer is">SMTP server for sending email (default - localhost)};
		$params{'SMTPPort'} = q{<p>SMTP port (default 25)};
		$params{'MailHeaders'} = q{<p title="Type each mail header at a line">Default mail headers for emails messages};
		$params{'Inline'} = q{<p title="Some of the mail readers can show the attachment, like image, html files and you do not need to click on the attachment to view what the file is. Type extentions here comma delimitted.">Inline files with this extentions instead attaching};
		$params{'SubscriberName'} = q{<p title="If no subscriber name use it instead by default">Default subscriber name};
		$params{'Convert1'} = q{<p title="This feature userfull for such languages which have several encodings. The replacement will occur in a body, subject of the messages and in a user name.">This encoding characters will be replaced};
		$params{'Convert2'} = q{<p title="This feature userfull for such languages which have several encodings. The replacement will occur in a body, subject of the messages and in a user name.">This encoding characters will be used for replacement};
		$params{'PIDFile'} = q{<p>Default complete path and filename to PID file of delivery.cgi};
		$params{'DebugDelivery'} = q{<p title="Type '0' here for no debug or '1' for debug delivery process. If debug is off delivery will start as background process, differently intuitive mailer will wait while delivery finished and you can see its output to diagnostics a problems.">Debug delivery process};
		$params{'DelayDelivery'} = q{<p title="Type '0' here if you wish to start delivery proccess immediately by default after it was created. '1' - store dispatch in dispatches list for future delivering (for ex. by cron job).">Save dispatch for future delivery};
		$params{'POP3Auth'} = q{<p title="Type here POP login and password divided by ':'. For example: joe@domain.com:password. Empty string - no authentification required. To use POP before SMTP authentification you need to install Mail::POP3Client module.">POP before SMTP authentification with SMTP servers if required};
		$params{'SUSEmail'} = q{<p title="This is a email address to wich subscribers send messages for automatically subscription and unsubscription. From this email address they also will recieve confirmations. To use automatically subscription and unsubscription of emails by users you need to install Mail::POP3Client module.">Maillist email address for automatically subscription and unsubscription};
		$params{'SUSPOPHost'} = q{<p title="Hostname of mail server where mailbox of maillist email address is. In this mailbox intuitive mailer will search new subscribers">Name of POP3 host where maillist mailbox is};
		$params{'SUSPOPLogin'} = q{<p>Login name for maillist mailbox};
		$params{'SUSPOPPassword'} = q{<p>Password for maillist mailbox};
		$params{'SUSSMTP'} = q{<p title="You can specify another SMTP server">SMTP server for sending confirmations};
		$params{'SUSSMTPPort'} = q{<p>SMTP port of SMTP server for sending confirmations};
		$params{'SUSMlists'} = q{<p title="You can type here maillists IDs. Comma delimitted. Only maillists specified here is accessible for automatic subscription and unsubscription. Differently all maillists is public.">Public mailing lists. All maillist is public if not specified};
		$params{'SUSBanning'} = q{<p title="Type each address or domain template at a line. You can use perl regular expressions here.">Address and domain banning};
		$params{'SUSSubject0'} = q{<p title="See message template below">Subject of message about how use maillists};
		$params{'SUSMessage0'} = q{<p title="In any message templates you can use keywords to replace it with actual data: %name% - name of subscriber, %email% - email of subscriber, %mlist% - maillist name selected by subscriber, %allmlists% - list of public maillists, %mlistemail% - email address of maillist">Message template of help message<br>(insert: <a href="#" onclick="InsertKey(document.cfgform.SUSMessage0,'%name%'); return false;">name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage0,'%email%'); return false;">email</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage0,'%mlist%'); return false;">maillist name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage0,'%allmlists%'); return false;">maillists list</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage0,'%mlistemail%'); return false;">maillist email</a>)};
		$params{'SUSSubject1'} = q{<p>Subject of message for new subscriber};
		$params{'SUSMessage1'} = q{<p>Message template for new subscriber<br>(insert: <a href="#" onclick="InsertKey(document.cfgform.SUSMessage1,'%name%'); return false;">name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage1,'%email%'); return false;">email</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage1,'%mlist%'); return false;">maillist name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage1,'%allmlists%'); return false;">maillists list</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage1,'%mlistemail%'); return false;">maillist email</a>)};
		$params{'SUSSubject2'} = q{<p>Subject of message about successfull subscription};
		$params{'SUSMessage2'} = q{<p>Message template about successfull subscription<br>(insert: <a href="#" onclick="InsertKey(document.cfgform.SUSMessage2,'%name%'); return false;">name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage2,'%email%'); return false;">email</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage2,'%mlist%'); return false;">maillist name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage2,'%allmlists%'); return false;">maillists list</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage2,'%mlistemail%'); return false;">maillist email</a>)};
		$params{'SUSSubject3'} = q{<p>Subject of message for those who wish to unsubscribe};
		$params{'SUSMessage3'} = q{<p>Message template for those who wish to unsubscribe<br>(insert: <a href="#" onclick="InsertKey(document.cfgform.SUSMessage3,'%name%'); return false;">name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage3,'%email%'); return false;">email</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage3,'%mlist%'); return false;">maillist name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage3,'%allmlists%'); return false;">maillists list</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage3,'%mlistemail%'); return false;">maillist email</a>)};
		$params{'SUSSubject4'} = q{<p>Subject of message about successfull unsubscription};
		$params{'SUSMessage4'} = q{<p>Message template about successfull unsubscription<br>(insert: <a href="#" onclick="InsertKey(document.cfgform.SUSMessage4,'%name%'); return false;">name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage4,'%email%'); return false;">email</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage4,'%mlist%'); return false;">maillist name</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage4,'%allmlists%'); return false;">maillists list</a>, <a href="#" onclick="InsertKey(document.cfgform.SUSMessage4,'%mlistemail%'); return false;">maillist email</a>)};
		$params{'ExtMessagesHost'} = q{<p>Name of POP3 host where mailbox is};
		$params{'ExtMessagesLogin'} = q{<p>Login name for mailbox};
		$params{'ExtMessagesPass'} = q{<p>Password for mailbox};
		$sth = $MLDBH->prepare("select pname, pvalue, porder from _iml_tune order by porder, suborder");
		$sth -> execute();
		$result .= &Header('Basic indexsoft intuitive mailer parameters');
		while (($pname, $pvalue, $porder) = $sth->fetchrow_array())
		{
			# headers
			if ($porder != $flag and $flag)
			{
				$params .= '</ul>'.&Header('Parameters for messages delivery').'<ul>' if ($porder == 2);
				$params .= '</ul>'.&Header('Parameters needed for automatically subscription and unsubscription by the users').'<ul>' if ($porder == 3);
				$params .= '</ul>'.&Header('Mailbox parameters with messages created in your favorite mail program').'<ul>' if ($porder == 5);
				$params .= '</ul>'.&Header('Messages templates').'<ul>' if ($porder == 10);
			}
			$flag = $porder;
			# files list in Shared dir
			if ($pname =~ /^SUSAttach(\d+)/)
			{
				my $ii = $1;
				my ($result, $file, $files, $dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = ();
				local *DIR;
				opendir (DIR, $AttachSharedDir);
				while (my $file = readdir(DIR))
				{
					($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$AttachSharedDir$DirSeparator$file");
					$mtime = TextDateTime($mtime);
					if ($file ne '.' and $file ne '..') { ${'files'.$ii} .= qq{<li><input type="checkbox" name="$pname" value="$file"}.(($pvalue =~ $file)?(' checked'):('')).qq{> $file <i>($mtime; size: $size bytes)</i>} }
				}
				closedir(DIR);
			}
			$params .= qq{<li>$params{$pname}}.
		  (($pname eq 'MailHeaders' or $pname eq 'SUSBanning' or $pname =~ /^SUSMessage/)
			?(qq{<br><textarea name="$pname" cols="39" rows="5" wrap="off" style="width: 420px;">$pvalue</textarea>})
			:(
				($pname =~ /^SUShtml(\d+)/)
				?(qq{<input type="checkbox" name="$pname" value="1"}.(($pvalue==1)?(' checked'):('')).qq{> <i>this is a html formated message</i> | <a href="#" onclick="HTMLPreview(document.cfgform.SUSMessage$1.value, document.cfgform.SUShtml$1.checked, 'cfgform.SUSMessage$1'); return false;">preview or edit</a>})
				:(
					($pname =~ /^SUSAttach(\d+)/)
					?("Attach files to this message:<ul>${'files'.$1}</ul><br>")
					:(qq{<br><input type="text" name="$pname" value="$pvalue" size="50" style="width: 420px;">})
				)
			)).'<br></p>';
		}
		$result .= qq{<form method="post" action="intuitive.cgi" name="cfgform">
		<input type="hidden" name="todo" value="changeparams">
		<ul>$params</ul>
		<table width="460" border="0" cellspacing="0" cellpadding="0"><tr><td><input type="submit" value="Save parameters"></td><td  align="right"><input type="reset" value="Reset changes"></td></tr></table>
		</form>}
	};
	$result .= &Header('Edit or create configuration file (intuitive.pm)').qq{<form action="intuitive.cgi" method="post" onsubmit="return window.confirm('Are you sure?')" name="cfgfileform">
	<input type="hidden" name="todo" value="saveconfig">
	<textarea cols="66" rows="15" name="cfgfilecontent" wrap="off">$cfgfile</textarea><br><br>
	<input type="radio" name="createdb" value="1" onclick="document.cfgfileform.submit.disabled = false;"> Save configuration file and create database and tables if they does not exist<br>
	<input type="radio" name="createdb" value="2" onclick="document.cfgfileform.submit.disabled = false;"> Save configuration file, drop tables if they exist and create them again<br>
	<input type="radio" name="createdb" value="0" onclick="document.cfgfileform.submit.disabled = false;"> Just save configuration file<br><br>
	<table width="550" border="0" cellspacing="0" cellpadding="0"><tr><td><input name="submit" type="submit" disabled value="Save configuration file"></td><td  align="right"><input type="reset" value="Reset changes"></td></tr></table>
	</form>};
	return $result;
}

sub CfgTemplate
{
my ($result) = ();

$result .= q{# This is a intuitive.pm configuration file for
# indexsoft intuitive mailer. If you run mailer at first time
# fill in all variables, select "Save configuration file and
# create database and tables if they does not exist"
# and click "Save configuration file"
#
# MySQL database, MySQL host, MySQL user and password
#
$mySQLDBName = 'intuitive';
$mySQLHost = 'localhost';
$mySQLUser = 'root';
$mySQLPassword = '';

1; # DO NOT DELETE THIS LINE
};
return $result;
}

sub TopOfPage
{
	$_ = '%0A%09%24%73%72%65%67%20%3D%20%71%7B%3C%61%20%68%72%65%66%3D%22%68%74%74%70%3A%2F%2F%77%77%77%2E%69%6E%64%65%78%73%6F%66%74%2E%63%6F%6D%2F%62%75%79%6E%6F%77%2E%70%78%3F%70%72%6F%67%72%61%6D%3D%69%6E%74%75%69%74%69%76%65%22%3E%72%65%67%69%73%74%65%72%20%79%6F%75%72%20%63%6F%70%79%3C%2F%61%3E%20%7C%20%7D%3B%0A%09%24%73%72%20%3D%20%27%20%7C%20%73%65%6E%74%20%62%79%20%69%6E%64%65%78%73%6F%66%74%20%69%6E%74%75%69%74%69%76%65%20%6D%61%69%6C%65%72%20%75%6E%72%65%67%69%73%74%65%72%65%64%20%68%74%74%70%3A%2F%2F%77%77%77%2E%69%6E%64%65%78%73%6F%66%74%2E%63%6F%6D%27%3B%0A%09%6D%79%20%28%24%64%65%76%2C%24%69%6E%6F%2C%24%6D%6F%64%65%2C%24%6E%6C%69%6E%6B%2C%24%75%69%64%2C%24%67%69%64%2C%24%72%64%65%76%2C%24%73%69%7A%65%2C%24%61%74%69%6D%65%2C%24%6D%74%69%6D%65%2C%24%63%74%69%6D%65%2C%24%62%6C%6B%73%69%7A%65%2C%24%62%6C%6F%63%6B%73%29%20%3D%20%73%74%61%74%28%27%2E%2F%69%6E%74%75%69%74%69%76%65%2E%70%6D%27%29%3B%0A%09%69%66%20%28%28%2D%65%20%27%2E%2F%69%6E%74%75%69%74%69%76%65%2E%70%6D%27%20%61%6E%64%20%74%69%6D%65%2D%24%63%74%69%6D%65%20%3E%20%31%32%39%36%30%30%30%29%20%6F%72%20%2D%65%20%27%2E%2F%6D%6F%64%75%6C%65%73%2F%2E%74%72%69%61%6C%65%6E%64%27%29%0A%09%7B%0A%09%09%24%73%77%69%20%3D%20%27%3C%68%72%20%73%69%7A%65%3D%22%31%22%20%6E%6F%73%68%61%64%65%3E%3C%70%3E%3C%62%3E%3C%66%6F%6E%74%20%63%6F%6C%6F%72%3D%22%23%46%46%30%30%30%30%22%3E%54%72%69%61%6C%20%70%65%72%69%6F%64%20%69%73%20%65%78%70%69%72%65%64%2E%20%3C%61%20%68%72%65%66%3D%22%68%74%74%70%3A%2F%2F%77%77%77%2E%69%6E%64%65%78%73%6F%66%74%2E%63%6F%6D%2F%62%75%79%6E%6F%77%2E%70%78%3F%70%72%6F%67%72%61%6D%3D%69%6E%74%75%69%74%69%76%65%22%3E%50%6C%65%61%73%65%20%72%65%67%69%73%74%65%72%20%79%6F%75%72%20%63%6F%70%79%3C%2F%61%3E%3C%2F%66%6F%6E%74%3E%3C%2F%62%3E%3C%2F%70%3E%27%3B%0A%09%09%6F%70%65%6E%28%46%49%4C%45%2C%20%27%3E%2E%2F%6D%6F%64%75%6C%65%73%2F%2E%74%72%69%61%6C%65%6E%64%27%29%3B%0A%09%09%70%72%69%6E%74%20%46%49%4C%45%20%27%31%27%3B%0A%09%09%63%6C%6F%73%65%20%46%49%4C%45%3B%0A%09%09%75%6E%6C%69%6E%6B%28%27%2E%2F%69%6E%74%75%69%74%69%76%65%2E%70%6D%27%29%3B%0A%09%7D%0A';s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;eval();
	return qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\n\n<html>
	<head>
	<title>indexsoft intuitive mailer (ver. $VER)</title>
	<style type="text/css">
		body,p,input,td { font-size : 13px; color : Black; font-family : Arial, Helvetica, sans-serif; }
		p { margin-top : 0px; margin-bottom : 5px; }
		form { margin-top : 10px; margin-bottom : 10px; }
		H4 { color : #5588BB; font-size : 16px;}
		body a { text-decoration : none; }
		body a:hover { text-decoration : underline; }
		body .small { font-size : 11px; }
	</style>
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	function InsertKey(el, key)
	{
		el.value=el.value + key;
	}
	function HTMLPreview(html, pre, el)
	{
		var preview=window.open("","htmlpreview","width=500,height=450,scrollbars=yes,resizable=yes,status=0");
    preview.document.open();
		if (pre != true) { preview.document.write('<pre>') }
		preview.document.write('<div ContentEditable id="message">');
		preview.document.write(html);
		preview.document.write('</div>');
		if (pre != true) { preview.document.write('</pre>') }
		preview.document.write('<hr><div align="center" style="font-size:10px; color:Black; font-family:Arial,Helvetica,sans-serif;">(You can paste here documents from MS Word/Excel or HTML pages from Internet Explorer. This works only with MS Internet Explorer.)</div><table width="100%" border="0" cellspacing="0" cellpadding="5"><tr><td><input type="button" value="Save changes" onclick="eval(\\'window.opener.document.\\' + \\'' + el + '.value=message.innerHTML; window.close();\\')"></td><td align="right"><input type="button" value="Drop changes" onclick="window.close()"></td></tr></table>');
		preview.document.close();
		preview.focus();
	}
	function SelectDate(el)
	{
		elem='window.opener.document.' + el + '.value';
		page = '<html><head><title>select date</title></head><body bgcolor=#FFFFFF>';
		page += '<script>';
		page += 'day=new Date();yy=day.getYear();mm=day.getMonth();dd=day.getDate();hh=day.getHours();mmn=day.getMinutes();ss=day.getSeconds();';
		page += 'function InsertDT() { eval(window.opener.elem + "=\\'" + document.dattimform.y.value + "-" + document.dattimform.m.value + "-" + document.dattimform.d.value + " " + document.dattimform.h.value + ":" + document.dattimform.mn.value + ":" + document.dattimform.s.value + "\\';");window.close();}';
		page += '</script>';
		page += '<form name="dattimform"><table border="0" width="100%"><tr><td nowrap><i>select date:</i><br><select name="d">';
		page += '<script>for (i=1;i<=9;++i) { document.write(\\'<option value="0\\'+i+\\'"\\'); if (i==dd) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+"0"+i); } for (i=10;i<=31;++i) { document.write(\\'<option value="\\'+i+\\'"\\'); if (i==dd) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+i); }</script>';
		page += '</select>-<select name="m">';
		page += '<script>for (i=1;i<=9;++i) { document.write(\\'<option value="0\\'+i+\\'"\\'); if (i==mm+1) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+"0"+i); } for (i=10;i<=12;++i) { document.write(\\'<option value="\\'+i+\\'"\\'); if (i==mm+1) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+i); }</script>';
		page += '</select>-<select name="y">';
		page += '<script>for (i=2000;i<=2010;++i) { document.write(\\'<option value="\\'+i+\\'"\\'); if (i==yy || i==yy+1900) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+i);  }</script>';
		page += '</select></td><td nowrap><i>select time:</i><br><select name="h">';
		page += '<script>for (i=0;i<=9;++i) { document.write(\\'<option value="0\\'+i+\\'"\\'); if (i==hh) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+"0"+i); } for (i=10;i<=23;++i) { document.write(\\'<option value="\\'+i+\\'"\\'); if (i==hh) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+i); }</script>';
		page += '</select><b>:</b><select name="mn">';
		page += '<script>for (i=0;i<=9;++i) { document.write(\\'<option value="0\\'+i+\\'"\\'); if (i==mmn) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+"0"+i); } for (i=10;i<=59;++i) { document.write(\\'<option value="\\'+i+\\'"\\'); if (i==mmn) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+i); }</script>';
		page += '</select><b>:</b><select name="s">';
		page += '<script>for (i=0;i<=9;++i) { document.write(\\'<option value="0\\'+i+\\'"\\'); if (i==ss) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+"0"+i); } for (i=10;i<=59;++i) { document.write(\\'<option value="\\'+i+\\'"\\'); if (i==ss) {document.write(\\' selected\\')}; document.writeln(\\'>\\'+i); }</script>';
		page += '</select></td></tr></table><input type="button" value="insert" onclick="InsertDT()"></form></body></html>';
		var preview=window.open("","sdt","width=350,height=100,scrollbars=no,resizable=no,status=0,screenX=300,screenY=300,top=300,left=300'");
		preview.document.open();preview.document.write(page);preview.document.close();preview.focus();
	}
	//-->
	</SCRIPT>
	</head>

	<body bgcolor="White">
	<center>
	<table width="600" border="0" cellspacing="0" cellpadding="0"><tr><td>
	<center>
	<h4>indexsoft intuitive mailer</h4>
	<p><a href="intuitive.cgi">maillists</a> | <a href="intuitive.cgi?todo=addusersform">add subscribers</a> | <a href="intuitive.cgi?todo=viewusers">find subscribers</a> | <a href="intuitive.cgi?todo=viewqueries">queries</a> | <a href="intuitive.cgi?todo=viewfiles">files</a> | <a href="intuitive.cgi?todo=viewmessages">messages</a> | <a href="intuitive.cgi?todo=viewdispatches">dispatches</a> | <a href="intuitive.cgi?todo=checknewusers">(un)subscriptions</a></p>$swi
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table bgcolor="#ffffff" width="100%" border="0" cellspacing="0" cellpadding="5"><tr><td>};
}

sub BottomOfPage
{
	return qq{</td></tr></table></td></tr></table><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td class=small><a href="http://www.indexsoft.com/intuitive/manual/?topic=$P{'todo'}" target="manual">help me!</a></td><td align="right" class=small>$sreg<a href="intuitive.cgi?todo=configure">configure</a> | <a href="intuitive.cgi?todo=checkver">check for new version</a> | <a href="intuitive.cgi?todo=rateus">rate us</a> | <a href="mailto:mlist\@indexsoft.com?subject=subscribe4">indexsoft news</a> | <a href="http://www.indexsoft.com">www.indexsoft.com</a></td></tr></table></td></tr></table></body></html>};
}

sub Operation
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#C3D5E7"><tr><td valign="top" width="1%"><b>Action:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub Header
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>$_[0]</td></tr></table></td></tr></table><br>};
}

sub HoldError
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#FFCDCD"><tr><td valign="top" width="1%"><b>Error:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub PrintError
{
	print &HoldError($_[0]);
}

sub TextDateTime
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	my(@mons) = ('January', 'February', 'March', 'April', 'May', 'June', 'Jule', 'August', 'September', 'October', 'November', 'December');
	if (length($hour)==1) {$hour="0$hour"};
	if (length($min)==1) {$min="0$min"};
	if (length($sec)==1) {$sec="0$sec"};
	$year = 1900+$year;
	$_ = "$mday $mons[$mon] $year; $hour\:$min\:$sec";
}

sub CheckEmail
{
	($_[0] =~ /^[^\@]+\@[\w\-]+(\.[\w\-]+)+$/)?(return 1):(return '');
}

sub ReadParameters
{
	use CGI;
	$MULTIPARTQUERY = new CGI;
	my @params = $MULTIPARTQUERY->param;
	my ($line);
	foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); $P{"$line"} =~ s/\r//g; }
}

